<!DOCTYPE html>
<html>
	<head>
		<title>Job Manager</title>
		<link rel="stylesheet" href="styles.css">
	</head>
	
	<body>
		<img id="logo" src="flexsimweb/images/logo.png" alt="FlexSim Logo"/>
		<div id="box">
			<div id="content">
				<?php
					session_start();
					
					if(!empty($_POST['btn_logout_submit']))
					{
						session_unset();
						header('location: jobs.php');
					}
					
					if(!isset($_SESSION["User"]))
					{
						header('location: login.php');
					}
					else
					{
						// connect to the local database
						$mysqli = new mysqli('localhost','fs_job_user','bW2ufszqc3mfWftG','fs_job_scheduler');
						if($mysqli->connect_error)
						{
							die("Connection error (".$mysqli->connect_errno."): ".$mysqli->connect_error);
						}
						
						// Pull the userid from the database
						if(!isset($_SESSION["UserID"]))
						{
							$query = 'SELECT * FROM fs_user WHERE username="'.$_SESSION["User"].'" LIMIT 1';
							if($result = $mysqli->query($query))
							{
								$entry = $result->fetch_assoc();
								if(isset($entry))
								{
									$_SESSION["UserID"] = $entry["userid"];
								}
							}
						}
						
						if(!isset($_SESSION['User']) || !isset($_SESSION['UserID']))
							die("Session error."); // Just in case
						
						$username = $_SESSION['User'];
						$userid = $_SESSION['UserID'];
						
						echo '<p class="inline">Hi, '.$username.'</p>';
						echo '<form class="inline" id="logoutForm" name="logoutForm" method="post">';
						echo '<p class="inline"><input id="btn_logout_submit" name="btn_logout_submit" type="submit" value="Log Out"></p>';
						echo '</form>';
						
						// change the webserver's ip address from 127.0.0.1 to the webserver's ip address
						// if the webserver isn't being hosted on the same machine as this website
						$webserveraddress = "http://127.0.0.1:81/webserver.dll";
						
						// get a list of available models
						$ch = curl_init($webserveraddress.'?availablemodels');
						curl_setopt($ch, CURLOPT_HEADER, false);
						curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
						$response = curl_exec($ch);
						curl_close($ch);
						if($response) // Make sure the Flexsim webserver is available
						{
							$availablemodels = json_decode(json_encode((array) simplexml_load_string($response)),1);
							
							if(!empty($_POST['btn_requestjob_submit']))
							{
								# sanitize the data
								$modelname = $mysqli->real_escape_string($_POST["modelname"]);
								$requestname = $mysqli->real_escape_string($_POST["requestname"]);
								
								$postdata = 'job={
										"modelname": "'.$modelname.'",
										"setupcommands": [
											{
												"command": "setrunspeed=50"
											},
											{
												"command": "run"
											}
										],
										"resultcommands": [
											{
												"command": ""
											}
										]
									}';
								
								$ch = curl_init($webserveraddress.'?submitjob');
								curl_setopt($ch, CURLOPT_HEADER, false);
								curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
								curl_setopt($ch, CURLOPT_POSTFIELDS, $postdata);
								$response = curl_exec($ch);
								curl_close($ch);
								if($response)
								{
									$jobid = $response;
									if(strlen($requestname) == 0)
										$requestname = "nameless run id".$jobid;
									
									// Add the request to the request table
									$query = 'INSERT INTO fs_request ( jobid, requestname, modelname ) VALUES ( "'.$jobid.'", "'.$requestname.'", "'.$modelname.'" );';
									if($result = $mysqli->query($query))
									{
										// Get the request id
										$query = 'SELECT * FROM fs_request WHERE jobid="'.$jobid.'" LIMIT 1';
										if($result = $mysqli->query($query))
										{
											$entry = $result->fetch_assoc();
											if(isset($entry))
											{
												$requestid = $entry["requestid"];
												// Link the request to the user
												$query = 'SELECT * FROM fs_user_request WHERE userid='.$userid.' AND requestid='.$requestid.' LIMIT 1';
												if($result = $mysqli->query($query))
												{
													$entry = $result->fetch_assoc();
													if(!isset($entry)) // make sure this linkage isn't already done (to avoid duplicate entries in the user_request table)
													{
														$query = 'INSERT INTO fs_user_request ( userid, requestid ) VALUES ( "'.$userid.'" , "'.$requestid.'" );';
														if($result = $mysqli->query($query))
														{
															header('location: jobs.php');
														}
													}
												}
											}
										}
									}
								}
								else echo "<p>Error submitting job.</p>";
							}
						}
						else
						{
							echo "<p>The FlexSim model server is down.</p>";
						}
						
						if(isset($availablemodels))
						{
							echo '<form id="requestjobForm" name="requestjobForm" method="post">';
							echo '<fieldset>';
							echo '		<legend>Run a Model</legend>';
							echo '		<p>';
							echo '			<label for="modelname">Available Models:</label>';
							echo '			<select name="modelname">';
											foreach($availablemodels['modelname'] as $modelname)
											{
												echo "<option>";
												echo $modelname;
												echo '</option>';
											}
							echo '			</select>';
							echo '		</p>';
							echo '		<p>';
							echo '			<label for="requestname">Run Name</label>';
							echo '			<input id="requestname" name="requestname" type="text">';
							echo '		</p>';
							echo '		<p>';
							echo '			<input id="btn_requestjob_submit" name="btn_requestjob_submit" type="submit" value="Submit Model Run Request">';
							echo '		</p>';
							echo '	</fieldset>';
							echo '</form>';
						}
						
						// get this user's requests and show them in a table
						$query = 'SELECT	fs_request.*
									FROM	fs_user, fs_user_request, fs_request
									WHERE	fs_user.userid = fs_user_request.userid AND
											fs_user_request.requestid = fs_request.requestid AND
											fs_user.userid='.$userid;
						if($result = $mysqli->query($query))
						{
							$entry = $result->fetch_assoc();
							if($entry)
							{
								echo '<form id="queryForm" name="queryForm" action="queries.php" method="post">';
								echo '<table border=1>';
								echo "<th> </th>";
								echo "<th>Run Name</th>";
								echo "<th>Model</th>";
								while($entry)
								{
									echo "<tr>";
									echo "<td><input name='jobid' value='".$entry["jobid"]."' type='radio'></td>";
									echo "<td>".$entry['requestname']."</td>";
									echo "<td>".$entry['modelname']."</td>";
									echo "</tr>";
									$entry = $result->fetch_assoc();
								}
								echo "<tr>";
								echo '<td colspan=3>';
								echo '<input id="btn_status" name="btn_status" type="submit" value="Status">';
								echo '<input id="btn_connect" name="btn_connect" type="submit" value="Connect">';
								echo '<input id="btn_cancel" name="btn_cancel" type="submit" value="Cancel">';
								#echo '<input id="btn_results" name="btn_results" type="submit" value="Results">'; // uncomment this if any of the models on the FlexSim webserver are configured to return results
								echo '</td>';
								echo "</tr>";
								echo "</table>";
								echo "</form>";
							}
						}
						
						
					}
				?>
			</div>
		</div>
	</body>
</html>